/*@[#]
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/4 (checked-out) "__DATE__" "__TIME__"  2009-10-26 08:44:25
 |  neuer What-Vermerk:   'f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >'
 |  voriger What-Vermerk: 'f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 38529c391265bd50f87c560facbebdb3
 |   Whitespace:   1d274074a7431b506d8daaa25678a379
 |   Linecomment:  a74ccd49f228e26a0ec08ac835ed02fa
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 */
/* decoElDaSp
   Dekodiert den Datenteil eines Unilink-Telegramms auf Kanal 0x889f
   mit location == 1040597888 Teil proj
   mit location == 1040597889 Teil var
   anhand der Informationen aus layoutData4Cobra.xml
 */

/** 
 * @since 2009-10-22 watl
 * - Neuerstellung
 */

// @since 2007-12-11 deck: bitset, string, vector
#include <bitset>
#include <string>
#include <vector>

#include "layoutData4Cobra.h"
#include "newlogtrace.hpp"

using namespace std;

// @since 2007-12-13 deck: whatstring
extern const char SOURCEID_decoElDaSp_cpp[]="<@(#)f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >";

CxmlNode* conf_root;
int    data_offset  = 12;     //(Ursprnglich) Relevanter Datenteil, d.h. ohne Telegrammheader und VKZ-Header

/**
 * Liefert den Identifikator-String dieser
 * Dekodier/Enkodier-DLL. Dieser String muss
 * static deklariert sein.
 *
 * @return Zeiger auf den Identifikator-String
 */
char *getIdent()
{
  static char ident[]={"decoElDaSp"};
  return ident;
}


int initDecode(char *pCnfname, void *)
{
  if (pCnfname == NULL) return -1;
  conf_root = parse_xml_file(pCnfname);
  if (conf_root != NULL) return 0;
  else return -1;
}


/**
 * Dekodiert xsay anhand der in der Konfigurationsdatei angegebenen Regeln.
 *
 * @since 2009-08-28 deck Baustelle.
 * 
 * @param pData
 *
 * @return dekodierte TraceMsg
 */
char *decode_xsay(BYTE *pData)
{
	
  static char str[4096];
  LogMsg_t *pMsg =(LogMsg_t *)pData;
  long loc = pMsg->id;
  
  if ( loc == 1040597888 || loc == 1040597889)
  {
  	sprintf(str,"[decoElDaSp] ");
    
    int len = pMsg->len;
    //Der undekodierte Hex-String wird zu Debug-Zwecken mit ausgegeben
    for (int i=0; i<len; i++) sprintf(str,"%s%02x ",str,pMsg->data[i]);
    sprintf(str,"%s\n[decoElDaSp]",str);
    
    unsigned long num = pMsg->num;
    //	  int  xsay_len = pData[15];
    int xsay_len = pMsg->len;
    
    //data[0..1]: Logikauftragsart (xsay: pdata[16..17])
  	long logikauftragsart = pMsg->data[0] + 256*pMsg->data[1];

    

    //Finde passende Definition fr Logikauftragsart
    CxmlNode* tg_tree = conf_root->getChild(NN_ROOT)->getChild(NN_TELEGRAMS);
    CxmlNode* av = NULL; //Der gewnschte <logicTelegram> Knoten
    if (tg_tree != NULL) {
      char val[10];
      sprintf(val,"%d",logikauftragsart);
      av = tg_tree->findChildByValue(NN_TELEGRAM,VN_VALUE,val);
      sprintf(val,"%d",logikauftragsart_byte);
      // @since 2008-01-08 deck: Falls es die lange logikauftragsart nicht gibt,
      // noch einmal mit der kurzen (ein Byte) versuchen. 
      // Es kann sein, dass eine lange logikauftragsart eine kurze verdeckt.
      // Um das zu vermeiden, msste geprft werden, ob bitscale==16.
      if (av==NULL) { 
        // @since 2008-01-08 deck: Auf Verdacht die kurze logikauftragsart_byte prfen.
        long logikauftragsart_byte=logikauftragsart%0x100; 
        sprintf(val,"%d",logikauftragsart_byte);
        av = tg_tree->findChildByValue(NN_TELEGRAM,VN_VALUE,val);
      }
      if (av==NULL) {
        //Keine passende Regel fr Logikauftragsart gefunden
        sprintf(str,"%s [No matching <logicTelegram> for val=%s]",str,val);
        return str;
      }
      else {
        //Telegrammnamen ausgeben @since 2009-09-02 deck Auf Wunsch von gim ohne Kanalformat.
        // sprintf(str,"%s [%s/%s] -",str,av->getAttribute(VN_NAME).c_str(),av->getAttribute(VN_CHNFRMT).c_str());
        sprintf(str,"%s [%s] -",str,av->getAttribute(VN_NAME).c_str());

        CxmlNode* tg_header = tg_tree->findChildByValue(VN_HEADER,VN_NAME,av->getAttribute(VN_HDRNAME).c_str());
        
         //ShiftByte-Parameter aus Header und LogicTelegram extrahieren
        int shift_header = 0;
        int shift_telegram = 0;
        string bs = tg_header->getAttribute(VN_SHIFT);
        if (strcmp(bs.c_str(),MX_NULL)) shift_header = atoi(bs.c_str());
        bs = av->getAttribute(VN_SHIFT);
        if (strcmp(bs.c_str(),MX_NULL)) shift_telegram = atoi(bs.c_str());

        shift_header+=16; // @since 2009-09-01 deck Bei xsay liegen die Daten 16 Byte weiter vorne als bei xtrace.
        shift_telegram+=16; // ...das gilt auch fr shift_telegram
        

        //<parameter> mittels der Funktion PARse parsen - zunchst die aus dem Header
        //Die zuletzt bearbeitete Byteposition wird gesichert
        int bp = PARse(tg_header,str,pMsg->data,shift_header,0,xsay_len);
        //Es folgen die <parameter> Werte aus dem Body, ab der letzten Byteposition aus dem Header
        PARse(av,str,pMsg->data,shift_telegram,bp,xsay_len);
    }
  }//endif (tg_tree)
     else {
      //Das im Header definierte Schlsselwort stimmt nicht mit der Eingabedatei berein
    	sprintf(str,"%s [ERROR: <%s> not found in XML file!]",str,NN_TELEGRAMS);
    }
    return str; 
} // endif
return NULL;
}



/**
 * Diese Funktion wird vom Televist aufgerufen (sozusagen main())
 * und verzweigt auf die beiden Hilfsfunktionen xsay.
 */
char *decode(int link, int datagrammart, int unilinkchannel, int len, BYTE *pData)
{
  switch (unilinkchannel)
  {
    case 0x889f: /*======== xsay =============================================*/
      {
        return decode_xsay(pData);

        break;
      };

    default:
      {
        return NULL;

        break;
      }
  }

  return NULL;
}


/**
 * Einstieg in die DLL-Bearbeitung
 *
 * @param hinstDll
 * @param fdwReason
 *
 * @return
 */
BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason,LPVOID) /*lpvReserved*/
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      { 
        return true;
        break;
      }

    case DLL_THREAD_ATTACH:
      {
        return true;
        break;
      }
    case DLL_THREAD_DETACH:
      { 
        return true;
        break;
      }

    case DLL_PROCESS_DETACH:
      { 
        return true;
        break;
      }

    default:
      { 
        return true;
        break;
      }
  }
}


/* Betrachtet die Bits von start bis start+length eines Bytes und gibt sie als int zurck
 * Returnwerte < 0 haben folgende Bedeutung:
 * -1 -> Das gegebene Byte ist NULL.
 *        @since 2007-12-13 deck: Paramater duerfen 0 sein, der Fehler wird nicht mehr ausgegeben.
 * -2 -> Das Byte ist lnger als acht Bits (Fehler in XML-Datei)
 * @since 2007-12-13 deck: Code ersetzt.
 */
int bitExtract(BYTE b, int start, int length)
{
  // if (b == NULL) return -1; //NULL-Byte
  if (start+length > 8) return -2; // byte overflow
  bitset<8> b_bitset(b);
  int result=0;
  for (int index=start+length-1; index>=start; --index) {
    result*=2;
    result+=b_bitset[index];
  }
  // cout << std::hex << int(b) << std::dec << " " << b_bitset << " start: " << start << " length: " << length << " result: " << result << endl;
  return result;
}


/* Geht durch alle <parameter>-Attribute des gegebenen Knotens und durchsucht sie nach den gewnschten Informationen
 * CxmlNode* n: Der Vaterknoten, der die <parameter>-Knoten enthlt
 * char* str: Der Ausgabestring, an den die Resultate angehngt werden sollen
 * BYTE* pData: zu dekodierender Datenstrom
 * int byteshift: accShiftByte-Wert aus dem Header, wird (ab Position 3) von der Byteposition abgezogen
 * int initial_bytePos: fange ab hier an zu dekodieren; default: 0
 * returns: zuletzt bearbeitete Byteposition
 * @since 2008-01-08 deck: Neuer Parameter length zum Stoppen der Dekodierung.
 */
int PARse(CxmlNode* n, char* str, BYTE *pData, int byteshift, int initial_bytePos, int length)
{
  int last_bytepos = 0; //Letzte Byteposition vor aktueller
  int current_bytepos = initial_bytePos; //Aktuelle Position
  bool newline=false; // @since 2008-01-08 deck: Einsparung von \n bei leeren Zeilen.
  if (n != NULL)
  {
    //CxmlNode* types = conf_root->getChild(NN_ROOT)->getChild(NN_ENUMTYPES);
    //Iteration ber alle Kinder namens <parameter> des Knotens n
    for (int i=1; i<=n->getChildNumberByName(VN_PARAM); i++)
    {
      CxmlNode* par = n->getChild(VN_PARAM,i);
      if (par != NULL)
      {
        last_bytepos = current_bytepos;
        current_bytepos = atoi(par->getAttribute(VN_BYTEPOS).c_str());
        if (current_bytepos > 2) current_bytepos -= byteshift;
        //es wird davon ausgegangen dass die "bytePos"-Werte chronologisch geordnet sind
        //dekodiere also nur, wenn die aktuelle Byteposition hher ist als die letzte
        // @since 2008-01-08 deck: Abfrage auf berschreitung von length.
        if ((current_bytepos >= last_bytepos) && (current_bytepos-4<length))
        {
          newline=true; // @since 2008-01-08 deck
          if (strcmp(par->getAttribute(VN_CONST).c_str(),MX_NULL))
            sprintf(str,"%s const@%s=",str,par->getAttribute(VN_BYTEPOS).c_str());
          else sprintf(str,"%s %s=",str,par->getAttribute(VN_NAME).c_str());
          //Werte knnen in Bytes oder Bits angegeben sein -
          //aber nie beides gleichzeitig; zB 12 Bit (1,5 Byte) lange Werte sind nicht erlaubt
          // @since 2008-01-08 deck: VN_BITSTOTAL statt VN_BITS (besser fr RC und kurze auftrg)
          int bitstotal=atoi(par->getAttribute(VN_BITSTOTAL).c_str());
          if (bitstotal >= 8)
          {
            //byteweise dekodieren
            if (bitstotal % 8 == 0)
            {
              for (int j=data_offset+current_bytepos; j<data_offset+current_bytepos+bitstotal/8; j++)
              {
                /*
                //Suche in <enumTypes> nach dem Datentypen
                CxmlNode* type = types->findChildByValue(NN_ENUMTYPE,VN_NAME,par->getAttribute(VN_TYPE));
                if (type != NULL) {
                  char val[10];
                  sprintf(val,"%d",hex2long(pData,j,1));
                  CxmlNode* item = type->findChildByValue("item","val",val);
                  sprintf(str,"%s%s ",str,item->getAttribute("name"));
                }
                else */ 
                sprintf(str,"%s%02x ",str,pData[j]);
              }
            }
            else sprintf(str,"%s [INVALID BYTE RANGE] ",str);
          }
          else
          {
            //bitweise dekodieren
            int start = atoi(par->getAttribute(VN_BITPOS).c_str());
            // @since 2008-01-08 deck: VN_BITS ersetzt durch VN_BITSTOTAL
            int end = atoi(par->getAttribute(VN_BITSTOTAL).c_str());
            // @since 2007-12-13 deck: data_offset fehlte
            int bitValue = bitExtract(pData[current_bytepos+data_offset],start,end);
            if (bitValue == -2) sprintf(str,"%s[INVALID BIT RANGE IN CONFIG FILE] ",str);
            else if (bitValue == -1) sprintf(str,"%sNULL ",str);
            else sprintf(str,"%s%d ",str,bitValue);
          }
        } //if current_bytepos
      } // if (par != NULL)
    } // for i
    if (newline) sprintf(str,"%s\n[decoElDaSp]",str); // @since 2008-01-08 deck. @since 2009-09-02 deck Mit Dekoration.
  } // if (n != NULL)
  return current_bytepos;
}


/*@[HISTORY]
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1wtha0_bw1b788c\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/1  2009-10-22 14:55:24
 |  neuer What-Vermerk:   'e5cedf3f15abe9a51fc5c5df803bb1c8 2009-10-22 14:55:24 decoElDaSp.cpp >'
 |  voriger What-Vermerk: 'ce8110ec4609180471397141856c244a 2009-09-02 10:22:04 xtrace_deco.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 1dc7e518c5b77c41b82cb032673ebcd3
 |   Whitespace:   3330b274371a46efb270b1cf80855bf7
 |   Linecomment:  d9d47d18edd2ee32c11383437e1b97ea
 |   Blockcomment: b61e0d08f8ec4f613b08cbde159476cb
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1wtha0_bw1b788c\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/1 (checked-out) "__DATE__" "__TIME__"  2009-10-22 15:52:45
 |  neuer What-Vermerk:   'e5cedf3f15abe9a51fc5c5df803bb1c8 2009-10-22 14:55:24 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >'
 |  voriger What-Vermerk: 'e5cedf3f15abe9a51fc5c5df803bb1c8 2009-10-22 14:55:24 decoElDaSp.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 1dc7e518c5b77c41b82cb032673ebcd3
 |   Whitespace:   3330b274371a46efb270b1cf80855bf7
 |   Linecomment:  d9d47d18edd2ee32c11383437e1b97ea
 |   Blockcomment: b61e0d08f8ec4f613b08cbde159476cb
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1wtha0_bw1b788c\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/2  2009-10-22 16:10:34
 |  neuer What-Vermerk:   'f7b26c679012f8a12eb2f301e4d7dc06 2009-10-22 16:10:34 decoElDaSp.cpp >'
 |  voriger What-Vermerk: 'e5cedf3f15abe9a51fc5c5df803bb1c8 2009-10-22 14:55:24 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 1dc7e518c5b77c41b82cb032673ebcd3
 |   Whitespace:   3330b274371a46efb270b1cf80855bf7
 |   Linecomment:  d9d47d18edd2ee32c11383437e1b97ea
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/2 (checked-out) "__DATE__" "__TIME__"  2009-10-22 16:12:41
 |  neuer What-Vermerk:   'f7b26c679012f8a12eb2f301e4d7dc06 2009-10-22 16:10:34 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >'
 |  voriger What-Vermerk: 'f7b26c679012f8a12eb2f301e4d7dc06 2009-10-22 16:10:34 decoElDaSp.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 1dc7e518c5b77c41b82cb032673ebcd3
 |   Whitespace:   3330b274371a46efb270b1cf80855bf7
 |   Linecomment:  d9d47d18edd2ee32c11383437e1b97ea
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/3  2009-10-23 11:10:29
 |  neuer What-Vermerk:   'c786362e08921a99b0296caa3d958c28 2009-10-23 11:10:29 decoElDaSp.cpp >'
 |  voriger What-Vermerk: 'f7b26c679012f8a12eb2f301e4d7dc06 2009-10-22 16:10:34 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 499177373606c02f9d36cf5d26ec8a4d
 |   Whitespace:   e283bfa2734ae58eeb1a67636d987343
 |   Linecomment:  a74ccd49f228e26a0ec08ac835ed02fa
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/3 (checked-out) "__DATE__" "__TIME__"  2009-10-23 11:10:46
 |  neuer What-Vermerk:   'c786362e08921a99b0296caa3d958c28 2009-10-23 11:10:29 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >'
 |  voriger What-Vermerk: 'c786362e08921a99b0296caa3d958c28 2009-10-23 11:10:29 decoElDaSp.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 499177373606c02f9d36cf5d26ec8a4d
 |   Whitespace:   e283bfa2734ae58eeb1a67636d987343
 |   Linecomment:  a74ccd49f228e26a0ec08ac835ed02fa
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/4  2009-10-23 16:20:59
 |  neuer What-Vermerk:   'f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp >'
 |  voriger What-Vermerk: 'c786362e08921a99b0296caa3d958c28 2009-10-23 11:10:29 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 38529c391265bd50f87c560facbebdb3
 |   Whitespace:   1d274074a7431b506d8daaa25678a379
 |   Linecomment:  a74ccd49f228e26a0ec08ac835ed02fa
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1mbes0_view\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_source\decoElDaSp.cpp'
 |  Version: /main/4 (checked-out) "__DATE__" "__TIME__"  2009-10-26 08:44:25
 |  neuer What-Vermerk:   'f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp (checked-out) "__DATE__" "__TIME__" >'
 |  voriger What-Vermerk: 'f671effbb49d2c7ff52782558fed5410 2009-10-23 16:20:59 decoElDaSp.cpp '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 38529c391265bd50f87c560facbebdb3
 |   Whitespace:   1d274074a7431b506d8daaa25678a379
 |   Linecomment:  a74ccd49f228e26a0ec08ac835ed02fa
 |   Blockcomment: bddb67926117cc1596b50047f00e1ab1
 |   Doc-Comment:  b8f4de8cecbec213e0ecbb295eee4026
*/
