/*@[#]
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1wtha0_bw1b788c\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_inc\deellell.h'
 |  Version: /main/1  2009-10-22 14:40:34
 |  neuer What-Vermerk:   '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h >'
 |  voriger What-Vermerk: '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 953c2424c768debb34fd42d4d1fab32d
 |   Whitespace:   2fd7ff092ddf38e2544762c4a8dcecd1
 |   Linecomment:  74b0d755a4a2b4b40f2158dd5c579ef4
 |   Blockcomment: 0bde8396116341d520b8258afba6a869
 |   Doc-Comment:  b92cf6ab45b5f45325bd1fff9b655de5
 */
#ifndef DEELLELL_H
#define DEELLELL_H

// mehrfache verwendete Deklarationen
#define DLLEXPORT __declspec( dllexport )
#define DLLIMPORT __declspec( dllimport )

const char *version_dellell_h="<@(#)0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h >";

/*
#ifdef LOAD_AUTOMATIC
// mittels diesem Schalter entfllt das dynamische Laden der Steuerdatei.
// die Steuer-DLL wird dann automatisch bei Programmstart geladen, die Funktionsadressen sind dem Programm
// bekannt. Das Projekt muss die Steuer-LIB mit einbinden
#define DLLIMPORTEXPORT DLLIMPORT
#endif
*/
#ifdef STEUER_DLL
// mittels diesem Schalter werden Funktionen der Steuer-DLL exportiert, anderfalls
// sind es Importe z.B. fr den Televist
#define DLLIMPORTEXPORT DLLEXPORT
#endif

#ifndef DLLIMPORTEXPORT
// default ist leerer String: kein Export oder Import
#define DLLIMPORTEXPORT
#endif

extern "C" 
{

/** *********************************************************************************
 * 
 * 1. Dekodier/Enkodier-DLL
 * ========================
 * 
 * exportiert Funktionen zum Dekodieren, Enkodieren und Initialisieren. Der Name der
 * DLL ist grundstlich beliebig, hat aber auf die Aufrufreihenfolge der Enkodier/
 * Dekodier-Funktion Einfluss. Siehe 2. Steuer-DLL.
 *
 * 
**/

/**
 * Optionale Funktion zum Abfragen des Identifikator-String
 * der Dekodier/Enkodier-DLL. Bentigt die DLL keine Konfigurations-
 * datei zur Initialisierung, so ist diese Funktion nicht
 * erforderlich.
 * 
 * @return Hier wird ein Zeiger auf einen Identifikator-String
 *         zurckgeliefert. Der Halter dieses statischen Strings
 *         ist die Dekodier/Enkodier-DLL
 */
DLLEXPORT
char *getIdent();

/**
 * Optionale Funktion zum Initialisieren der Dekodier-DLL.
 * Bentigt die Dekodier-DLL eine Konfigurationsdatei,
 * so muss sie diese Funktion zur Verfgung stellen.
 * 
 * @param pCnfname NULL. ignorieren
 *                 !=NULL Name einer Konfigurationsdatei. Kann
 *                 auch ein Zeiger auf eine Struktur im Speicher
 *                 sein.
 * 
 * @return 0: Fehlerfrei Initialisiert
 *         -1: Fehler bei Initialisierung
 */
DLLEXPORT
int initDecode(char *pCnfname, void *pCnfData=NULL);

/**
 * Dekodiert das bergebene Unilink-Datagramm.
 * 
 * @param link    Link-Schnittstelle. Nummerierung:
 *                1..4:   Unisa-Schnittstellenkarte
 *                5..7:   LinkBox EPP-Port 0x378, oder Dimo
 *                8..10:  Linkbox EPP-Port 0x278
 *                11..20: USB-Box, via RJ45
 *                21..30: USB-Box, via LWL
 * @param datagrammart
 *                Art des Unilink-Formats:
 *                0: Datagrammart Steuertelegramm
 *                1: Datagrammart UDP
 *                2..0x1a: frei
 *                0x1b: Datagrammart ESC-Sequenz
 *                0x1c..0xff: frei
 * @param channel Unilink-Channel 0x0000..0xffff
 * @param len     Lnge der Nutzdaten in Byte
 * @param pData   [out] Zeiger auf Nutzdaten
 * 
 * @return ==NULL:        konnte nicht dekodiert werden
 *         Zeiger auf "": dekodiert, soll nicht dargestellt werden.
 *         Zeiger auf dekodierten String:
 *             Darf gngige Html-Formatierungen (z.b. entsprechend CSS2) enthalten.
 *
 */
DLLEXPORT
char *decode(int link, int datagrammart, int channel, int len, BYTE *pData);

/**
 * Optionale Funktion zum Initialisieren der Enkodier-DLL.
 * Bentigt die Enkodier-DLL eine Konfigurationsdatei,
 * so muss sie diese Funktion zur Verfgung stellen.
 * 
 * @param pCnfname NULL. ignorieren
 *                 !=NULL Name einer Konfigurationsdatei. Kann
 *                 auch ein Zeiger auf eine Struktur im Speicher
 *                 sein. Z.B. knnte der Televist Informationen
 *                 (Handles und Bezeichner) seiner Bedienelemente
 *                 bergeben.
 * 
 * @return 0:  Fehlerfrei initialisiert
 *         -2: Fehler bei Initialisierung
 */
DLLEXPORT
int initEncode(char *pCnfname, void *pCnfData=NULL);

/**
 * Enkodierung der Anweisungen an Televist.
 * 
 * @param pInputStr [out] Eingabezeile
 * @param pLink     [in] Extrahierter Link
 *                       wenn nicht ermittelbar: 0
 * @param pDatagrammart
 *                  [in]Extrahierte Datagrammart
 * @param pChannel  [in] Extrahierter Channel
 * @param pLen      [out] Maximallnge des zurckzugebenden Datagramms
 *                  [in] Lnge des Datagramms in pData
 * @param pData     [in] Enkodiertes Datagramm ohne Datagrammart,
 *                  ohne Channel, ohne Prfsumme.
 *                  Data muss ein komplettes Unilink-Datagramm aufnehmen
 *                  knnen.
 * @param pRedecoded [in] wie Eingabezeile, aber in standardisierter Formatierung
 * 
 * @return == -1     String soll nicht enkodiert werden
 *         == 0      Keine Enkodiervorschrift vorhanden.
 *         == 1      ok
 */
DLLEXPORT
int encode(char *pInputStr, 
                int *pLink, int *pDatagrammart, int *pChannel,
                int *pLen, BYTE *pData, char *pRedecoded);
/** ***************************************************************************************
 * 
 * 2. Steuer-DLL
 * =============
 * 
 * Enthlt den Steuermechanismus zum Laden der DLL mit den Dekodier- und Enkodier-Funktionen.
 * Stellt auch selber jeweils eine Dekodier- und Enkodier-Funktion zur Verfgung, welche
 * dann alle anderen Funktionen in folgender Reihenfolge aufruft:
 *
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn kein 0 bzw. NULL-Zeiger zurckgegeben
 * 
**/

/**
 * Setzt das DLL-Verzeichnis und ldt die darin enthaltenen
 * DLLs
 * 
 * @param pDirectory != NULL: Verzeichnis, auf dem die DLL zu finden sind
 *                   == NULL: Aktuelles DLL-Verzeichnis (eigenes Dir)
 * @param ppaIdent   nach erfolgreicher Initialisierung wird hier ein
 *                   Zeiger zurckgeliefert. Dieser zeigt auf ein
 *                   Array von Strings. Fr jede gefundene DLL ist
 *                   dort eine Identifizierung abgelegt, oder der DLL-Name,
 *                   wenn sich die DLL nicht identifizieren mchte.
 *                   Der Halter des statischen Arrays ist die Steuer-DLL;
 *                   Die statischen Identifizierungs-Strings werden von
 *                   den jeweiligen Enkodier- bzw. Dekodier-DLL gehalten.
 * 
 * @return >0 Anzahl gefundener DLL mit deco- oder enco-Funktion
 *         0: Keine DLL gefunden
 *         <0 Fehlerhafte Pfadangabe
 * @see getIdent
 */
DLLIMPORTEXPORT
int initCodecs(char *pDirectory, char **ppaIdent[]);

 /**
 * Optionaler Funktionsaufruf zum Initialisieren der
 * mittels initCodecs() ermittelten DLL
 * 
 * @param nr         0 < Laufende Nr der DLL < initcodecs(..)
 * @param decode_cnf !=NULL Zeiger auf Struktur mit Initialisierungsdaten,
 *                   wenn nicht anders vereinbart ist dies ein NULL-terminierter
 *                   String mit dem Filenamen zur initialisierung des Dekoders
 *                   Wird unverndert an initDecode() weitergegeben, sofern vorhanden.
 *
 *                   NULL   keine Initialisierung erforderlich
 *
 * @param encode_cnf !=NULL Zeiger auf Struktur mit Initialisierungsdaten,
 *                   wenn nicht anders vereinbart ist dies ein NULL-terminierter
 *                   String mit dem Filenamen zur initialisierung des Enkoders
 *                   Wird unverndert an initEncode() weitergegeben, sofern vorhanden.

 *                   NULL   keine Initialisierung erforderlich
 * 
 * @return 0: Dekoder und Enkoder erfolgreich initialisiert
 *         -1: Initialisierung Dekoder fehlerhaft.
 *         -2: Initialisierung Enkoder fehlerhaft.
 *         -3: Initialisierung Dekoder und Enkoder fehlerhaft.
 *
 * @see initDecode
 * @see initEncode
 */
DLLIMPORTEXPORT
int initConfigs(char *pIdent, char *decode_cnf, char *encode_cnf, void *pDecodeData=NULL, void *pEncodeData=NULL);

/**
 * Optionale Funktion zum Aktivieren/Deaktivieren der Dekodier/Enkodier-DLL.
 * Als default ist die DLL aktiviert
 * 
 * @param pIdent: Identifikator der DLL
 * @param enable: 0 DLL deaktivieren
 *                1 DLL aktivieren
 * 
 * @return 0 letzter Zustand war: aktiviert
 *         1 letzter Zustand war: deaktiviert
 *        -1 DLL nicht gefunden
 */
DLLIMPORTEXPORT
int enableDll(char *pIdent, int enable);
/**
 * Funktion zum entladen der Dekodier/Enkodier-DLL.
 * 
 * @return 0 fehlerfrei abgeschlossen
 *        -1 Fehler beim entladen
 */
DLLIMPORTEXPORT
int unloadAllDll();
/**
 * Definition des Funktionstyps fr getIdent. Die Steuer-DLL
 * muss sich die Adresse der getIdent-Funktion jeder Enkoder/Dekoder-DLL
 * in einer Variablen von diesem Typ abspeichern.
 * 
 * werden in mehr als einer Enkoder/Dekoder-DLL GetIdent-Funktionen
 * gefunden, so werden diese in folgender Reihenfolge zur
 * Ausfhrung gebracht:
 * 
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn kein NULL-Zeiger zurckgegeben
 */
typedef char *(*GETIDENT_FNC)();
/**
 * Definition des Funktionstyps fr initEncode. Die Steuer-DLL
 * muss sich die Adresse der initEncode-Funktion jeder Enkoder-DLL
 * in einer Variablen von diesem Typ abspeichern.
 * 
 * werden in mehr als einer Enkoder-DLL initEncode-Funktionen
 * gefunden, so werden diese in folgender Reihenfolge zur
 * Ausfhrung gebracht:
 * 
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn kein NULL-Zeiger zurckgegeben
 */
typedef int (*INITENCODE_FNC)(char *pCnfname, void *pCnfData);
/**
 * Definition des Funktionstyps fr InitDecode. Die Steuer-DLL
 * muss sich die Adresse der InitDekode-Funktion jeder Dekoder-DLL
 * in einer Variablen von diesem Typ abspeichern.
 * 
 * werden in mehr als einer Dekoder-DLL InitDecode-Funktionen
 * gefunden, so werden diese in folgender Reihenfolge zur
 * Ausfhrung gebracht:
 * 
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn kein NULL-Zeiger zurckgegeben
 */
typedef int (*INITDECODE_FNC)(void *pCnfname, void *pCnfData);
/**
 * Definition des Funktionstyps fr decode. Die Steuer-DLL
 * muss sich die Adresse der decode-Funktion jeder Dekoder-DLL
 * in einer Variablen von diesem Typ abspeichern.
 * 
 * werden in mehr als einer Dekoder-DLL decode-Funktionen
 * gefunden, so werden diese in folgender Reihenfolge zur
 * Ausfhrung gebracht:
 * 
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn kein NULL-Zeiger zurckgegeben
 */
typedef char * (*DECODE_FNC)(int link, int datagrammart, int channel, int len, BYTE *pData);

/**
 * Definition des Funktionstyps fr encode. Die Steuer-DLL
 * muss sich die Adresse der encode-Funktion jeder Enkoder-DLL 
 * in einer Variablen von diesem Typ abspeichern.
 * 
 * werden in mehr als einer Enkoder-DLL encode-Funktionen
 * gefunden, so werden diese in folgender Reihenfolge zur
 * Ausfhrung gebracht:
 * 
 * 1. Aufsteigend alphabetisch des DLL-Namens.
 * 2. Abbruch, wenn keine 0 zurckgegeben
 */
typedef int (*ENCODE_FNC)(char *pInputStr, int *pLink, int *pDatagrammart, int *pChannel, int *pLen, BYTE *pData, char *pRedecoded);

/** ******************************************************************************************
 * 
 * 3a. Laden und Initialisieren der Steuer-DLL aus einem beliebigen Programm
 * ==========================================================
 * 
 * In diesem Abschnitt wird beschrieben, wie die Steuer-DLL initialisiert
 * werden kann, einschliesslich der erforderlichen Typdefinitionen
 * 
 * 
 * Beispiel zum Laden der Steuer-DLL mittels LoadLibrary
 * 
 * HMODULE hSteuerDLL = LoadLibrary("CODECTRL" ); 
 *
 * Hinweis: Einfacher ist natrlich das Einbinden von "codectrl.lib". Das laden der
 *          DLL erfolgt dann automatisch und alle Funktionen sind direkt aufrufbar.
 * 
 * 
 **/

/**
 * Definition des funktionstyps fr initCodecs
 * 
 * mittels initCodecs werden alle DLL geladen, die sich im 
 * spezifizierten Pfad befinden. Es erfolgt eine aufsteigende
 * Sortierung aufgrund des Namens der DLLs. Die von den DLL 
 * exportierten Funktionen werden aufgrund der Sortierung in
 * die entsprechende Reihenfolge gebracht.
 * 
 * Beispiel zur Verwendung:
 * 
 * char **ppaIdent=NULL;
 * 
 * INITCODECS pInitCodecs=(INITCODECS) GetProcAddress(hSteuerDLL,"initCodecs");
 * 
 * int anzahlCodecs=pInitCodecs("D:\\verzeichnis",ppaIdent);
 * 
 */
typedef int (*INITCODECS_FNC)(char *pDirectory, char **ppaIdent[]);

/**
 * Definition des funktionstyps fr initConfigs. Existiert
 * fr die jeweilige Dekodier-DLL bzw. Enkodier-DLL ein
 * Identifikator, und ist (mindestens) eine Konfigurationsdatei fr
 * diese DLL zugeordnet, so erfolgt die Initialisierung.
 * 
 * Beispiel zur Verwendung:
 * 
 * INITCONFIGS pInitConfigs=(INITCONFIGS) GetProcAddress(hSteuerDLL,"initConfigs");
 * 
 * for(int iDLL=0; iDLL<anzahlConfigs; iDLL++)
 * {
 *      char *pIdent=ppIdent+i;
 *      void *decode_cnf=... // abhngig von pIdent ermitteln, z.B. mit strScan evtl NULL
 *      void *encode_cnf=... // abhngig von pIdent ermitteln, z.B. mit strScan, evtl NULL
 * 
 *      pInitConfigs(iDLL,decode_cnf,encode_cnf)
 * 
 */
typedef int (*INITCONFIGS_FNC)(char *pIdent, char *decode_cnf, char *encode_cnf, void *pDecodeData, void *pEncodeData);

/**
 * Definition des funktionstyps fr enableDll. Als Default ist eine
 * geladene Enkodier/Dekodier- DLL immer akiviert. Sie kann nachtrglich
 * deaktiviert bzw. wieder aktiviert werden.
 * 
 * Beispiel zur Verwendung:
 * 
 * ENABLEDLL pEnableDll=(ENABLEDLL) GetProcAddress(hSteuerDLL,"EnableDll");
 * 
 * Im EventHandler fr "id" der Windows-Applikation:
 * 
 *  CString pId;
 *  CMenu *m=GetMenu();
 *  UINT state=m->GetMenuState(id,MF_BYCOMMAND);
 *  m->GetMenuString(id,pId,MF_BYCOMMAND);
 *  if (state & MF_CHECKED)
 *  {
 *      m->CheckMenuItem(id, MF_UNCHECKED | MF_BYCOMMAND);
 *      pEnableDll(pId.GetBuffer(),0);
 *
 *  } else
 *  {
 *      m->CheckMenuItem(id, MF_CHECKED | MF_BYCOMMAND);
 *      pEnableDll(pId.GetBuffer(),1);
 *  }
 *
 *
 * 
 */
typedef int (*ENABLEDLL_FNC)(char *pIdent, int enable);
/**
 * Definition des funktionstyps fr unloadAllDll(). 
 *
 */
typedef int (*UNLOADALLDLL)();

/** *******************************************************************************************
 * 
 * 3b. Verwendung der Steuer-DLL aus einem beliebigen Programm
 * ==========================================================
 * 
 * In diesem Abschnitt wird beschrieben, wie die Steuer-DLL verwendet
 * werden kann, einschliesslich der erforderlichen Typdefinitionen
 * 
 * 
 * Beispiel zur Verwendung:
 * 
 * DECODE_FNC pDecode=(DECODE_FNC) GetProcAddress(hSteuerDLL,"decode");
 * 
 * char *pDecodedString=pDecode(7,1,0x1234,20,pData);
 * 
 * ENCODE_FNC pEncode=(ENCODE_FNC) GetProcAddress(hSteuerDLL,"encode");
 * 
 * int link=0;
 * int datagrammart=0;
 * int channel;
 * BYTE  aData[128];
 * int len=sizeof(aData);
 * int ret=pEncode(pDecodedString,&link,&channel,&len,&aData,pRedecodedString);
 * 
 **/

/** ******************************************************************************************
 * 
 * 4. Implementierung im Televist
 * ============================
 *
 * - Der Televist ldt die Steuer-DLL 
 * - Er ermittelt mit initcodecs() die vorhandenen Encoder/Decoder-DLL 
 * 
 * Folgende DLL werden vom Televist zur Verfgung gestellt:
 * 
 * - borgdeco.DLL
 *
 *   Dekodier-DLL welche auf deco.cnf zugreift 
 * 
 *   liefert Identifikator "BORG_DECO"
 *
 * 
 * - logntrace.DLL
 *   
 *   Dekodier-DLL welche auf xlog-Katalog zugreift. 
 * 
 *   liefert Identifikator "LOGNTRACE_DECO"
 *
 * 
 * - TvIntern.DLL
 *
 * - Dekodier/Enkodier-DLL mit den heute im Televist enthaltenen Dekodierungen und Enkodierungen; 
 *
 *   Enkodiert die aktuellen Televist-Konsoleneingaben.
 *
 *   liefert Identifikator "TELEVIST_DECO_ENCO"
 *
 *
 * nach aufruf von initcodecs() werden dann mindestens folgende Identifikatoren zurckgeliefert:
 *
 * "BORG_DECO",
 * "LOGNTRACE_DECO",
 * "TELEVIST_INTERN"
 * 
 * in Televist.ini sind dann fr jeden Identifikator Eintrge zu schreiben:
 * 
 * [BORG_DECO]
 *   ConfigFileDeco='..\CNF\deco.cnf';
 *    ; ConfigFileEnco nicht erforderlich
 *    Disabled=1;    Bei Televiststart nicht benutzen
 * 
 * [XLOG_DECODE]
 *    ConfigFileDeco='..\CNF\LogAndTrace.msg';
 *    ; ConfigFileEnco nicht erforderlich
 *    Disabled=1;    Bei Televiststart nicht benutzen
 * 
 *
 * [TELEVIST_INTERN]
 *    ; ConfigFileDeco nicht erforderlich
 *    ; ConfigFileEnco nicht erforderlich
 *    Disabled=0;    Bei Televiststart sofort benutzen
 * 
 *
 *
 * alle Pfade verstehen sich releativ zur Programmposition der Steuer-DLL.
 * im Falle von drei DLL erfolgen dann diese Initialisierungen:
 *
 * initConfigs("BORG_DECO", (void*)"..\Cnf\deco.cnf", NULL );
 * initConfigs("LOGNTRACE_DECO", (void*)"..\Cnf\LogAndTrace.msg", NULL );
 * initConfigs("TELEVIST_DECO_ENCO", NULL, NULL); 

 * Bei fehlenden Identifikatoren entfllt der initConfigs()-Aufruf.
 * Bei Identifikator-Eintrgen wird jeweils mit NULL initialisiert.
*/
} // extern "C"
#endif
/*@[HISTORY]
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1eckw0_dynview\SIMISW_DEV\_section\Diagnostics\_comp\televist_De_En_Coder\_mod\Chonos\_src\deellell.h'
 |  Version: /main/1  2005-02-25 15:39:05
 |  neuer What-Vermerk:   '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h >'
 |  voriger What-Vermerk: ' '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 953c2424c768debb34fd42d4d1fab32d
 |   Whitespace:   2fd7ff092ddf38e2544762c4a8dcecd1
 |   Linecomment:  74b0d755a4a2b4b40f2158dd5c579ef4
 |   Blockcomment: 0bde8396116341d520b8258afba6a869
 |   Doc-Comment:  b92cf6ab45b5f45325bd1fff9b655de5
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1decg0_view\SIMISW_DEV\_tools\integration\televist_plugins\xtracedeco\_inc\deellell.h'
 |  Version: /main/1  2007-08-23 11:39:42
 |  neuer What-Vermerk:   '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h >'
 |  voriger What-Vermerk: '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 953c2424c768debb34fd42d4d1fab32d
 |   Whitespace:   2fd7ff092ddf38e2544762c4a8dcecd1
 |   Linecomment:  74b0d755a4a2b4b40f2158dd5c579ef4
 |   Blockcomment: 0bde8396116341d520b8258afba6a869
 |   Doc-Comment:  b92cf6ab45b5f45325bd1fff9b655de5
 +---
 |  Signaturblock erzeugt von 'signatur_c' Version #20010910EW
 |  File: 'M:\bw1wtha0_bw1b788c\SIMISW_DEV\_tools\integration\televist_plugins\decoElDaSp\_inc\deellell.h'
 |  Version: /main/1  2009-10-22 14:40:34
 |  neuer What-Vermerk:   '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h >'
 |  voriger What-Vermerk: '0e363f599b402926a6593b996d1bdba3 2005-02-25 15:39:05 deellell.h '
 |   (What-Signatur enthaelt Code und Comment ohne Whitespace und Sign-Bloecke)
 |  neue Signaturen in Rubriken:
 |   compilierbar: 953c2424c768debb34fd42d4d1fab32d
 |   Whitespace:   2fd7ff092ddf38e2544762c4a8dcecd1
 |   Linecomment:  74b0d755a4a2b4b40f2158dd5c579ef4
 |   Blockcomment: 0bde8396116341d520b8258afba6a869
 |   Doc-Comment:  b92cf6ab45b5f45325bd1fff9b655de5
*/
