/**
  Pointer auf irgendetwas
*/
typedef void far* PTR;


/**
   Wegen Alignment sollte es mglich sein, Pointerscaling auf 8 Byte zu zerren.
   Dafr wird eine Allingment-Union verwendet, die ber den Pointer ein 8 Byte
   groes Datenfeld legt.
*/
typedef union {
         UINT32 pointerPartDWORD[2];  // not to be used as Variable!
         PTR    pointer;              // forced to 8 Byte scaling
} PTRUNION;


// Struktur des Telegrammes, das sie LogMsg enthlt
//     Die Struktur umfasst ohne data' exakt 40 Bytes.
struct LogMsg_t
{
  WORD    magic;   // "LM"=0x4d4c  fr Logmessage;
  BYTE    reserved; // soll 0 sein solange nicht genutzt
  BYTE    tasknum;  // 1..100, da es max 100 Tasks gibt. 
  // 0 = ohne Taskbezug
  UINT32  id;   // Id der Logmsg (LogMsg_Id)
  WORD    allSum; // bisher gesendete Anzahl von LogMsg 
  //   ber alle Tasks
  WORD    taskSum;  // bisher gesendete Anzahl von LogMsg 
  //   dieser Task
    // (6.5.4) Do not redefine keywords or names from the standard headers. (time)
    /* SUPPRESS 6.5.4 */// Wir benutzen keine Standardheader
  UINT32  time; // timestamp in ms
  PTRUNION  callPoint;  // LDTR#CS:EIP des Aufrufpunktes des 
  //    xlog() oder xtrace()
  PTRUNION  pData;  // LDTR#Sel:Offset des Datenfeldes dieser LogMsg
  INT32 num;    // numerischer Parameter dieser LogMsg 
  // (LogMsg_Num)
  INT32 len;    // Anzahl Bytes des Datenbereiches 
  //    oder 2. numerischer Parameter (LogMsg_Len)
  // flexibel langer Datenbereich von 0..64 Bytes (LogMsg_pData):
    BYTE    data[64];  /* SUPPRESS 6.10.1a */// 64 nicht magisch!
};


